import java.net.*;
import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.geom.*;

public class UDPWinShareRecv implements Runnable {
    public static final int maxPixels = 128;
    public static final int maxlen = 4 * 2 + 3 * maxPixels; // int x, int y, (byte r, byte g,byte b) * maxPixels
    UDPServer serv;
    ToyGraphics tg;
    
    public UDPWinShareRecv(UDPServer serv, ToyGraphics tg) {
	this.serv = serv;
	this.tg = tg;
    }
    public void run() {
	DatagramPacket pkt = new DatagramPacket(new byte[maxlen],maxlen);

	System.out.println("start");
	try {
	    for (;;) {
		synchronized (serv) {
		    serv.receive(pkt);
		}
		byte[] data = Arrays.copyOfRange(pkt.getData(), pkt.getOffset(), pkt.getLength());
		int x = mkInt(data[0],data[1],data[2],data[3]);
		int y = mkInt(data[4],data[5],data[6],data[7]);
		int n=(data.length - 4*2)/3;   // number of pixels
		//System.err.println(x+" "+y+" "+n);
		synchronized (tg.g2d) {
		    for (int i=0; i<n; i++) {
			int r = data[4*2+3*i] & 0xff;
			int g = data[4*2+3*i+1] & 0xff;
			int b = data[4*2+3*i+2] & 0xff;
			tg.setRGB(x+i,y,r,g,b);
		    }
		    tg.repaint(x,y,n,1);
		}
		pkt.setLength(maxlen);
	    }
	} catch (IOException e) {
	    System.err.println("io exception");
	}

	System.out.println("stop");
	serv.close();
    }
    int mkInt(byte a,byte b,byte c,byte d) {
	int n = ((a << 24) & 0xff000000) + ((b << 16) & 0x00ff0000)
	    + ((c << 8) & 0x0000ff00) + (d & 0x000000ff);
	return n;

    }
}
